﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Drawing;

namespace CC.Utilities.Tests
{
    /// <summary>
    ///This is a test class for ColorExtensionsTest and is intended
    ///to contain all ColorExtensionsTest Unit Tests
    ///</summary>
    [TestClass]
    public class ColorExtensionsTest
    {
        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext { get; set; }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion

        /// <summary>
        ///A test for Invert
        ///</summary>
        [TestMethod]
        public void InvertTest()
        {
            Color color = Color.FromArgb(0, 0, 0);
            Color expected = Color.FromArgb(255, 255, 255);
            Color actual = color.Invert();
            Assert.AreEqual(expected, actual);
        }

        /// <summary>
        ///A test for ToColorRef
        ///</summary>
        [TestMethod]
        public void ToColorRefTest()
        {
            Color color = Color.White;
            const uint expected = 16777215;
            uint actual = color.ToColorRef();
            Assert.AreEqual(expected, actual);
        }
    }
}
